
QGIS Application - Bug report #17155

Crash when creating XYZ layer from python

2017-09-18 10:34 AM - Hugo Mercier

Status: Closed

Priority: Normal

Assignee: Alessandro Pasotti

Category: Data Provider

Affected QGIS version:master Regression?: No

Operating System: Linux Ubuntu Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:Yes Copied to github as #: 25054

Description

Try something like

l = QgsVectorLayer("crs=EPSG:3857&format&type=xyz&url=http://b.tile.openstreetmap.org/{z}/{x}/{y}.png&zmax=18&zmin=0",

"wms", "wms")

It kabooms in QgsVectorLayer::setDataProvider, when calling updateFields()

Observed with qgis 2.18 and 2.99

Adding this XYZ layer works fine with the browser

Associated revisions

Revision 2523d735 - 2017-11-07 09:26 AM - Alessandro Pasotti 

[bugfix] Prevent a bad crash when provider is wrong

Fixes #17155

History

#1 - 2017-09-18 10:45 AM - Nyall Dawson

- Status changed from Open to Feedback

Shouldn't that be QgsRasterLayer?

#2 - 2017-09-18 11:24 AM - Hugo Mercier

- Resolution set to invalid

Of course it is ... !

Works correctly with a QgsRasterLayer, thanks. I did not get enough coffee this morning apparently ... :/

What is a bit confusing is that it does not immediately return and says the provider is unknown. I guess this is because "wms" is also a raster provider.
#3 - 2017-11-06 02:51 PM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#4 - 2017-11-07 09:29 AM - Alessandro Pasotti

- Pull Request or Patch supplied changed from No to Yes

- Resolution deleted (invalid)

Not fixable due to this cast: https://github.com/qgis/QGIS/blob/master/src/core/qgsvectorlayer.cpp#L1538

I don't know the reason why the dynamic cast was removed, but maybe time to re-introduce it

See: https://github.com/qgis/QGIS/pull/5552

#5 - 2017-11-07 11:56 AM - Anonymous

- % Done changed from 0 to 100

- Status changed from Feedback to Closed

Applied in changeset commit:qgis|2523d7351cf166b15941edd707586951a30ed54b.
